require 'json'
require "swagger/template/endpoint"

module Swagger
  module Template
    class Tasks
      class Reader
        def initialize(path)
          @path = path
        end

        # Reads out the required info from the provided path
        def read
          specs = read_swagger_specs(@path)
          endpoints = extract_endpoints(specs)
          # enrich_all(endpoints)
        end

        private

        # Extract every path from the endpoints, generating a list of endpoints
        # and related data
        def extract_endpoints(specs)
          specs.map do |spec|
            spec['paths'].keys.map do |path|
              spec['paths'][path].keys.map do |verb|
                Swagger::Template::Endpoint.new(spec, path, verb)
              end
            end
          end.flatten
        end

        # Reads the Swagger specs from the path
        def read_swagger_specs(path)
          Dir["#{path}/**/*.json"].map do |filename|
            JSON.parse(File.read(filename))
          end
        end
      end
    end
  end
end
