require 'erb'
require 'fileutils'

module Swagger
  module Template
    class Tasks
      class Writer
        def initialize(options = {})
          @endpoints = options[:endpoints]
          @options = options
        end

        def write
          @endpoints.each do |endpoint|
            render('endpoint', endpoint)
          end
        end

        def render(filename, endpoint)
          @template_filename = "#{@options[:templates_path]}" \
                               "/#{@options[:language]}/#{filename}.erb"
          @template = File.read(@template_filename)
          rendered = ERB.new(@template, nil, '-').result(binding).tap{|ob| puts ob }
          directory = "#{@options[:output_path]}/#{endpoint.dirname}"
          filename = "#{@options[:output_path]}/#{endpoint.filename}.rb"

          FileUtils.mkdir_p(directory) unless File.directory?(directory)

          File.open(filename, 'w') { |file| file.write(rendered) }
        end
      end
    end
  end
end
